include dlldecl.inc
.data
sthread STHREAD <>
;---------------------------------------------------------------------------
Hinstance dd 0
InfosFichiers 		WIN32_FIND_DATA <>	
AppName db "DLL editmasm",0
HelloMsg db "Fonction de la dll retrouver par GetProcAddress",0
Recopie db "Phrase passer dans la memoire ",0
LoadMsg db "The DLL is loaded",0
UnloadMsg db "The DLL is unloaded",0
ThreadCreated db "A thread is created in this process",0
ThreadDestroyed db "A thread is destroyed in this process",0
ppvHelp2 dd 0
ppvIh2vmain dd 0
ppvIHxRegNamespaceList 	dd 0
ppvIHxRegistryWalker 	dd 0
ppvIHxRegNamespace	dd 0
countdll dd 0
 pe PROCESSENTRY32 <>
IID_Help2 GUID sIID_Help2
szdexplore db "dexplore.exe",0
HprocessDexplore dd 10 dup (0)
IID_Ih2vmain GUID <77B80B8Eh,63B9h,40E6h,<8Dh,0D3h,0CCh,0F8h,33h,13h,3Bh,0Fh>>
IID_IHxRegistryWalker GUID <314111EFh,0A502h,11D2h,<0BBh,0CAh,00h,0C0h,04Fh,8Eh,0C2h,94h>> ;IHxRegistryWalker
CLSID_HxRegistryWalker GUID <314111f0h,0a502h,11d2h,<0bbh,0cah,00h,0c0h,4fh,8eh,0c2h,94h>> ;	HxRegistryWalker
array_bstr dd 10 dup (0)
.code
			;le end DllEntry fixe le nom du proc appel 
			;pour initialiser la dll

DllEntry proc hInstance:DWORD, reason:DWORD, reserved1:DWORD
	.if reason==DLL_PROCESS_ATTACH		
		inc countdll
		mov eax,hInstance
		mov Hinstance,eax		
		;invoke MessageBox,NULL,addr LoadMsg,addr AppName,MB_OK
	.elseif reason==DLL_PROCESS_DETACH
		dec countdll
		;invoke MessageBox,NULL,addr UnloadMsg,addr AppName,MB_OK
	.elseif reason==DLL_THREAD_ATTACH
		;invoke MessageBox,NULL,addr ThreadCreated,addr AppName,MB_OK
	.else        ; DLL_THREAD_DETACH
		;invoke MessageBox,NULL,addr ThreadDestroyed,addr AppName,MB_OK
	.endif
	mov  eax,TRUE
	ret
DllEntry Endp
;-------------------------------------------------------------------------------------

;################################################################
StartHelp2 PROC 
	Local reponse:DWORD,pbstrFilter,bstrFilter
	LOCAL wszNull[8]:Word	
	Local  retour:DWORD	
	ZEROLOCALES retour
		.if countdll == 1
			Invoke CoInitializeEx,NULL,COINIT_APARTMENTTHREADED		
			;invoke DebugBreak	
			invoke GarantirCreateToolhelp32Snapshot
			.if eax == 1
				invoke IsrunningDexploreFirst      ;Voir si instances dja prsentes
				;le fait d'appeler l'interface va crer une autre instance
				invoke InitHelp2
				.if eax == 1	;ok ppvHelp2 valide
					;prendre la collection par dfaut
					mov reponse,0
					Help2 Collection,addr reponse
					.if eax == S_OK && reponse != 0
						;create null string pour le filtre
						invoke MultiByteToWideChar,CP_ACP,NULL,addr bstrFilter,-1,addr wszNull,sizeof wszNull
						invoke SysAllocString,addr wszNull
						mov  	pbstrFilter,eax
						;----------------------------------------------------					
						Help2 SetCollection,reponse,pbstrFilter	;filtre null
						.if eax != S_OK
							Help2 Close
							Help2 Release
							mov ppvHelp2,0
						.else
						invoke IsrunningDexploreNew
							.if eax == 0
								;no new process found,there was invisible dexplore before
								;invalide la destruction du process
								mov pe.th32ProcessID,0
								Help2 Close
								Help2 Release
								mov ppvHelp2,0								
							.endif							
						.endif	
						invoke SysFreeString,reponse
						invoke SysFreeString,pbstrFilter							
					.else
						call Failed_Init_Help2
					.endif
				.endif
			.endif
		.endif
 FindeStartHelp2:
         mov eax,retour
         ret
Failed_Init_Help2:
	Help2 Release
	mov ppvHelp2,0	
retn

StartHelp2 endp

;################################################################

EndHelp2 PROC 
			Local  retour:DWORD
         mov retour,0
		.if countdll == 1
			.if ppvHelp2 != 0
				Help2 Close
				Help2 Release
				mov ppvHelp2,0
				;verifier que dexplore n'est plus en mmoire
				invoke DetruireProcess
			.endif
			invoke CoUninitialize
		.endif
 FindeEndHelp2:
         mov eax,retour
         ret
EndHelp2 endp

;################################################################
ValidHelp2 PROC 
			Local  retour:DWORD
	.if ppvHelp2 == 0
		mov retour,0
	.else
		mov retour,1
	.endif
 FindeValidHelp2:
         mov eax,retour
         ret
ValidHelp2 endp

;################################################################



;################################################################
DLLContents PROC   
			Local  retour:DWORD
         mov retour,1
	Help2 Contents
 FindeDLLContents:
         mov eax,retour
         ret
DLLContents endp

;################################################################
DLLIndex PROC   
			Local  retour:DWORD
         mov retour,1
	Help2 Index
 FindeDLLIndex:
         mov eax,retour
         ret
DLLIndex endp

;################################################################
DLLSearch PROC   
			Local  retour:DWORD
         mov retour,1
	Help2  Search
 FindeDLLSearch:
         mov eax,retour
         ret
DLLSearch endp

;################################################################

DLLIndexResults PROC   
			Local  retour:DWORD
	Help2 IndexResults
 FindeDLLIndexResults:
         ret
DLLIndexResults endp

;################################################################
DLLSearchResults PROC   
			Local  retour:DWORD
	Help2 SearchResults
 FindeDLLSearchResults:
         ret
DLLSearchResults endp

;################################################################
 
DLLDisplayTopicFromId PROC  bstrFile:DWORD,Id:DWORD 
			Local  retour:DWORD
         mov retour,1
	Help2 DisplayTopicFromId,bstrFile,Id
 FindeDLLDisplayTopicFromId:
         ret
DLLDisplayTopicFromId endp

;################################################################
DLLDisplayTopicFromURL PROC pszURL:DWORD
			Local  retour:DWORD
         mov retour,1
	Help2 DisplayTopicFromURL,pszURL
 FindeDLLDisplayTopicFromURL:
         ret
DLLDisplayTopicFromURL endp

;################################################################

DLLDisplayTopicFromURLEx  PROC  pszURL:DWORD,pIVsHelpTopicShowEvents:DWORD
			Local  retour:DWORD
         mov retour,1
	Help2 DisplayTopicFromURLEx,pszURL,pIVsHelpTopicShowEvents

 FindeDLLDisplayTopicFromURLEx :
         ret
DLLDisplayTopicFromURLEx  endp

;################################################################

DLLDisplayTopicFromKeyword PROC  pszKeyword:DWORD
			Local  retour:DWORD
         mov retour,1
	Help2 DisplayTopicFromKeyword,pszKeyword
 FindeDLLDisplayTopicFromKeyword:
         ret
DLLDisplayTopicFromKeyword endp

;###############################################################
DLLDisplayTopicFromF1Keyword PROC   pszKeyword:DWORD
			Local  retour:DWORD
         mov retour,1
	Help2 DisplayTopicFromF1Keyword,pszKeyword
 FindeDLLDisplayTopicFromF1Keyword:
         ret
DLLDisplayTopicFromF1Keyword endp

;################################################################

DLLDisplayTopicFrom_OLD_Help PROC  bstrFile:DWORD,Id:DWORD
			Local  retour:DWORD
         mov retour,1
	Help2 DisplayTopicFrom_OLD_Help,bstrFile,Id
 FindeDLLDisplayTopicFrom_OLD_Help:
         ret
DLLDisplayTopicFrom_OLD_Help endp

;################################################################

DLLSyncContents PROC  bstrURL:DWORD
			Local  retour:DWORD
         mov retour,1
	Help2 SyncContents,bstrURL
 FindeDLLSyncContents:
         ret
DLLSyncContents endp

;################################################################

DLLCanSyncContents PROC  bstrURL:DWORD
			Local  retour:DWORD
         mov retour,1
	Help2 CanSyncContents,bstrURL
 FindeDLLCanSyncContents:
         ret
DLLCanSyncContents endp

;################################################################

DLLGetNextTopic PROC  bstrURL:DWORD,pbstrNext:DWORD 
			Local  retour:DWORD
         mov retour,1
	Help2 GetNextTopic, bstrURL,pbstrNext
 FindeDLLGetNextTopic:
         ret
DLLGetNextTopic endp

;################################################################
DLLGetPrevTopic PROC   bstrURL:DWORD,pbstrPrev:DWORD 
			Local  retour:DWORD
         mov retour,1
	Help2 GetPrevTopic,bstrURL,pbstrPrev
 FindeDLLGetPrevTopic:
         ret
DLLGetPrevTopic endp

;################################################################

;################################################################
DLLFilterUI PROC   
			Local  retour:DWORD
         mov retour,1
	Help2 FilterUI
 FindeDLLFilterUI:
         ret
DLLFilterUI endp

;#############################################################


         
DLLCanShowFilterUI PROC 
			Local  retour:DWORD
         mov retour,1
	Help2 CanShowFilterUI
 FindeDLLCanShowFilterUI:
         ret
DLLCanShowFilterUI endp

;################################################################

DLLClose PROC  
			Local  retour:DWORD
         mov retour,1
	Help2 Close
 FindeDLLClose:
         ret
DLLClose endp

;################################################################

DLLSyncIndex PROC  bstrKeyword:DWORD,fShow:DWORD 
			Local  retour:DWORD
         mov retour,1
	Help2 SyncIndex, bstrKeyword,fShow
 FindeDLLSyncIndex:
         ret
DLLSyncIndex endp

;################################################################

DLLSetCollection PROC  bstrCollection:DWORD,bstrFilter:DWORD 
			Local  retour:DWORD
         mov retour,1
	Help2 SetCollection,bstrCollection,bstrFilter
 FindeDLLSetCollection:
         ret
DLLSetCollection endp

;################################################################
DLLCollection PROC  pbstrCollection:DWORD
			Local  retour:DWORD
         mov retour,1
	Help2 Collection,pbstrCollection
 FindeDLLCollection:
         ret
DLLCollection endp

;################################################################

DLLFilterout PROC  pbstrFilter:DWORD
			Local  retour:DWORD
         mov retour,1
	Help2 Filterout,pbstrFilter
 FindeDLLFilterout:
         ret
DLLFilterout endp

;################################################################
DLLFilterin PROC  pbstrFilter:DWORD
			Local  retour:DWORD
         mov retour,1
	Help2 Filterin,pbstrFilter
 FindeDLLFilterin:
         ret
DLLFilterin endp

;##############################################################         
DLLHelpOwnerout PROC  ppObj:DWORD
			Local  retour:DWORD
         mov retour,1
;ne rien faire,il faut ajouter les proc d'appel pour utiliser le
;pointeur d'interface fourni
	;Help2 HelpOwnerout,ppObj
 FindeDLLHelpOwnerout:
         ret
DLLHelpOwnerout endp

;################################################################

DLLHelpOwnerin PROC  ppObj:DWORD
			Local  retour:DWORD
         mov retour,1
	;Help2 HelpOwnerin,ppObj
 FindeDLLHelpOwnerin:
         ret
DLLHelpOwnerin endp

;################################################################

DLLHxSession PROC  ppObj:DWORD 
			Local  retour:DWORD
         mov retour,1
	;Help2 HxSession,ppObj
 FindeDLLHxSession:
         ret
DLLHxSession endp

;################################################################
DLLHelp PROC  ppObj:DWORD 
			Local  retour:DWORD
         mov retour,1
	;	Help2 Help,ppObj
 FindeDLLHelp:
         ret
DLLHelp endp

;################################################################
DLLGetObject PROC bstrMoniker:DWORD,bstrOptions:DWORD,ppDisp:DWORD 
			Local  retour:DWORD
         mov retour,1
	Help2 GetObject1,bstrMoniker,bstrOptions,ppDisp
 FindeDLLGetObject:
         ret
DLLGetObject endp

;################################################################

;################################################################
DLLSearchEx PROC  bstrSearchFilterTransform:DWORD,pszSearchTerm:DWORD,
					vssfSearchFlags:DWORD 
			Local  retour:DWORD
         mov retour,1
	Help2 SearchEx,bstrSearchFilterTransform,pszSearchTerm,vssfSearchFlags
 FindeDLLSearchEx:
         ret
DLLSearchEx endp

;################################################################

DLLHowDoI PROC  
			Local  retour:DWORD
         mov retour,1
	Help2 HowDoI

 FindeDLLHowDoI:
         ret
DLLHowDoI endp

;################################################################

DLLFavorites PROC   
			Local  retour:DWORD
         mov retour,1
	Help2 Favorites
 FindeDLLFavorites:
         ret
DLLFavorites endp

;################################################################

DLLAskAQuestion PROC  askQuestionFlags:DWORD 
			Local  retour:DWORD
         mov retour,1
	Help2 AskAQuestion,askQuestionFlags
 FindeDLLAskAQuestion:
         ret
DLLAskAQuestion endp

;################################################################
DLLDisplayTopicFromURLEx2 PROC  bstrURL:DWORD,displayUrlFlags:DWORD,bstrParam:DWORD
			Local  retour:DWORD
         mov retour,1
	Help2 DisplayTopicFromURLEx2,bstrURL,displayUrlFlags,bstrParam
 FindeDLLDisplayTopicFromURLEx2:
         ret
DLLDisplayTopicFromURLEx2 endp

;################################################################

DLLInitializeSettingsToken PROC  bstrSettingsToken:DWORD 
			Local  retour:DWORD
         mov retour,1
	Help2 InitializeSettingsToken,bstrSettingsToken
 FindeDLLInitializeSettingsToken:
         ret
DLLInitializeSettingsToken endp

;################################################################
;--------------------------- non export -------------------------------------------
;################################################################
InitHelp2 PROC 
			Local  retour:DWORD
			;Local   :DWORD
			;Local    [LimiteMaxPhrase]:BYTE 
         mov retour,0
		.if ppvHelp2 == 0
			invoke GetInterfaceFromProgId,SADR("DExplore.AppObj.9.0"),addr IID_Help2
			.if eax > 10
				mov ppvHelp2,eax
				mov retour,1
			.endif
		.endif
 FindeInitHelp2:
         mov eax,retour
         ret
InitHelp2 endp

;################################################################
GetInterfaceFromProgId PROC pProgId:DWORD,pIID:DWORD
	LOCAL wszProgID[1024]:word
	LOCAL ppv:Dword,retour,pchaine		
	LOCAL clsid	:GUID
	mov retour,0
	invoke MultiByteToWideChar,CP_ACP,MB_PRECOMPOSED,pProgId,-1,addr wszProgID,sizeof wszProgID
	invoke CLSIDFromProgID,addr wszProgID,addr clsid
	.if eax == S_OK
		;CLSCTX_INPROC_SERVER or CLSCTX_INPROC_HANDLER or CLSCTX_LOCAL_SERVER
		invoke CoCreateInstance,addr clsid, NULL,	
		  CLSCTX_INPROC_SERVER or CLSCTX_INPROC_HANDLER or CLSCTX_LOCAL_SERVER,
			pIID,addr ppv
		.if eax == S_OK 			
			PuPo retour,ppv
		.elseif eax == REGDB_E_CLASSNOTREG		;for debugging use
			mov retour,2		
		.elseif eax == E_OUTOFMEMORY
			mov retour,3		
		.elseif eax == E_INVALIDARG
			mov retour,3		
		.elseif eax == E_UNEXPECTED
			mov retour,4		
		.elseif eax == CLASS_E_NOAGGREGATION
			mov retour,5		
		.else
			mov retour,6
		.endif
	.endif
	mov eax,retour
	RET
GetInterfaceFromProgId endp
IsrunningDexploreFirst PROC 
			Local  retour:DWORD,count,hSnapshot
		mov retour,0
		mov count,0
		;---------------------------------------------------
		invoke CreateToolhelp32Snapshot,TH32CS_SNAPPROCESS,0
		mov hSnapshot,eax
		mov pe.dwSize,sizeof PROCESSENTRY32
		invoke Process32First,hSnapshot,addr pe
		.while(eax)
			invoke lstrlen,addr pe.szExeFile
			.if eax == strsize(dexplore.exe)
				invoke lstrcmpi,addr pe.szExeFile,addr szdexplore ;text compare
				.if eax == 0
					lea edx,HprocessDexplore
					mov ecx,LENGTHOF HprocessDexplore -1
					@@:
					.if dword ptr [edx] != 0
						dec ecx
						.if ecx == 0
							jmp FindeIsrunningDexploreFirst 
						.endif
						add edx,4
						jmp @B
					.else
						PuPo [edx],pe.th32ProcessID
					.endif
				.endif
			.endif
			invoke Process32Next,hSnapshot,addr pe
		.endw
		mov retour,1	;all process dexplore have been memorized
 FindeIsrunningDexploreFirst:
		invoke CloseHandle,hSnapshot
         	mov eax,retour
         ret
IsrunningDexploreFirst endp

;################################################################

IsrunningDexploreNew PROC 
			Local  retour:DWORD,count,hSnapshot
		mov retour,0
		mov count,0
		;---------------------------------------------------
		invoke CreateToolhelp32Snapshot,TH32CS_SNAPPROCESS,0
		mov hSnapshot,eax
		mov pe.dwSize,sizeof PROCESSENTRY32
		invoke Process32First,hSnapshot,addr pe
		.while(eax)
			invoke lstrlen,addr pe.szExeFile
			.if eax == strsize(dexplore.exe)
				invoke lstrcmpi,addr pe.szExeFile,addr szdexplore ;text compare
				.if eax == 0
					lea edx,HprocessDexplore
					@@:
					.if dword ptr [edx] != 0
						mov ecx,pe.th32ProcessID
						.if ecx == [edx]
							jmp NewProcess
						.endif
						add edx,4
						jmp @B
					.else
						;this process is unknown,it's the new
						;and pe.th32ProcessID is this process
						mov retour,1
						.break						
					.endif
				.endif
			.endif
			NewProcess:
			invoke Process32Next,hSnapshot,addr pe
		.endw
 FindeIsrunningDexploreNew:
	   invoke CloseHandle,hSnapshot
         mov eax,retour
         ret
IsrunningDexploreNew endp

;################################################################
GarantirCreateToolhelp32Snapshot PROC 
			Local   osinfo:OSVERSIONINFO
			Local  retour:DWORD
			;Local    [LimiteMaxPhrase]:BYTE 
         mov retour,1
		mov osinfo.dwOSVersionInfoSize,sizeof OSVERSIONINFO
		invoke GetVersionEx,addr osinfo
		mov eax,osinfo.dwPlatformId
		and eax,VER_PLATFORM_WIN32_NT
		.if eax != 0
			.If osinfo.dwMajorVersion < 5
				mov retour,0	;
			.endif			
		.endif

 FindeGarantirCreateToolhelp32Snapshot:
         mov eax,retour
         ret
GarantirCreateToolhelp32Snapshot endp


DetruireProcess PROC 
	Local Hprocess:dword,ExitCode
	mov  Hprocess,0
	mov ExitCode,0	
	; un process est il deja en cours ? si oui confirmer
	; sa destruction, sinon creer
	.if pe.th32ProcessID != 0
		invoke OpenProcess,PROCESS_ALL_ACCESS,FALSE, pe.th32ProcessID 
		.if eax != 0
			mov Hprocess,eax 
				invoke GetExitCodeProcess,Hprocess, ADDR ExitCode
				.if eax == 0
					;la fonction a chou,on vite de tout bloquer
					;invoke RetrouveMessageErreur,SADR("GetExitCodeProcess erreur")	
					;invoke MessageBox,NULL,SADR("GetExitCodeProcess erreur"),ADDR szDisplayName,MB_YESNO       				
					mov eax,TRUE
					jmp FindeDetruireProcess		
				.endif
		.else
			jmp FindeDetruireProcess
		.endif				
	.else
		mov eax,TRUE
		jmp FindeDetruireProcess				
	.endif
	;------------------ Destruction -------------------------------------
	.if ExitCode==STILL_ACTIVE
		;invoke MessageBox,NULL,ADDR MesDetruireProcess,ADDR szDisplayName,MB_YESNO       
		;.if eax==IDYES
		; ne pas lancer deux programmes en meme temps 
			;le process peut s'etre termin le temps de la messagebox	
			invoke GetExitCodeProcess,Hprocess,ADDR ExitCode
			.if ExitCode==STILL_ACTIVE
				;invoke ExitProcess,ExitCode ;pas de retour   
				invoke TerminateProcess,Hprocess,0
				.if eax == 0
					;invoke RetrouveMessageErreur,SADR("Message TerminateProcess erreur")
					invoke MessageBox,NULL,SADR("Autoriser la cration d'un nouveau process ?"),SADR("Message TerminateProcess erreur"),MB_YESNO
					.if eax == IDYES
						mov eax,TRUE
					.else
						mov eax,FALSE	;pas libre
					.endif
					jmp FindeDetruireProcess
				.else
					mov pe.th32ProcessID,0
					;destruction russie,ne rien demander continuer
					mov eax,FALSE	;autoriser le lancement du process
					jmp FindeDetruireProcess					
				.endif
			.else
				mov pe.th32ProcessID,0
			.endif
			;------- la voie est libre -------------------
			mov eax,TRUE ;la voie est libre,on peut lancer un nouveau process	
		;.else
		;	mov eax,FALSE
		;.endif
	.else
		;pas de process en cours
		mov eax,TRUE	            
	.endif

FindeDetruireProcess:
	ret
DetruireProcess endp

				 
				
;################################################################
DLLURLout PROC   pbstrUrl:DWORD 
	Ih2vmain URLout,pbstrUrl
 FindeURLout:
         ret
DLLURLout endp

;################################################################

DLLURLin PROC  bstrUrl:DWORD 
	Ih2vmain URLin,bstrUrl
 FindeURLin:
         ret
DLLURLin endp

;################################################################

DLLVersion PROC   pversion:DWORD 
	Ih2vmain Version,pversion
 FindeVersion:
         ret
DLLVersion endp

;################################################################

DLLShowWindow PROC   rhs:DWORD 
			Local  retour:DWORD
	Ih2vmain ShowWindow,rhs
 FindeDLLShowWindow:
         ret
DLLShowWindow endp

;################################################################
DLLCurrentNS PROC   paVisState:DWORD 
	Ih2vmain CurrentNS,paVisState
 FindeDLLCurrentNS:
         ret
DLLCurrentNS endp

;################################################################

DLLOpen PROC  aURL:DWORD ,aFilterName:DWORD, aFilterQuery :DWORD
	Ih2vmain Open,aURL,aFilterName,aFilterQuery
 FindeDLLOpen:
         ret
DLLOpen endp

;################################################################
DLLFilterNameout PROC  pnameout:DWORD 
	Ih2vmain FilterNameout,pnameout
 FindeDLLFilterNameout:
         ret
DLLFilterNameout endp

;################################################################
DLLFilterNamein PROC  namein:DWORD 
	Ih2vmain FilterNamein,namein
 FindeDLLFilterNamein:
         ret
DLLFilterNamein endp

;################################################################
DLLFilterQueryout PROC   pfilter:DWORD 
	Ih2vmain FilterQueryout,pfilter
 FindeDLLFilterQueryout:
         ret
DLLFilterQueryout endp

;################################################################

DLLFilterQueryin PROC  filter:DWORD 
	Ih2vmain FilterQueryin,filter
 FindeDLLFilterQueryin:
         ret
DLLFilterQueryin endp

;################################################################

DLLQueryForURL PROC  aNS:DWORD,  aSearchTerm:DWORD, aNavDataMoniker :DWORD,
				  aFilterQueryStr:DWORD, aOptions:DWORD,  pRetVal:DWORD 
	Ih2vmain QueryForURL,aNS,aSearchTerm,aNavDataMoniker,aFilterQueryStr,aOptions,pRetVal
 FindeDLLQueryForURL:
         ret
DLLQueryForURL endp

;################################################################

DLLWindowHandle PROC  pWindowHandle:DWORD 
	Ih2vmain WindowHandle,pWindowHandle
 FindeDLLWindowHandle:
         ret
DLLWindowHandle endp

;################################################################
DLLCloseH2viewer PROC  
	Ih2vmain Close
 FindeDLLCloseH2viewer:
         ret
DLLCloseH2viewer endp

;################################################################

DLLV1 PROC  ptruc:DWORD 
	Ih2vmain V1,ptruc
 FindeDLLV1:
         ret
DLLV1 endp

;################################################################
DLLV2 PROC  ptruc:DWORD 
	Ih2vmain V2,ptruc
 FindeDLLV2:
         ret
DLLV2 endp

;################################################################

DLLV3 PROC  ptruc:DWORD 
	Ih2vmain V3,ptruc
 FindeDLLV3:
         ret
DLLV3 endp

;################################################################
DLLV4 PROC  ptruc:DWORD 
	Ih2vmain V4,ptruc
 FindeDLLV4:
         ret
DLLV4 endp

;################################################################

DLLBusy PROC  pstate:DWORD 
	Ih2vmain Busy,pstate
 FindeDLLBusy:
         ret
DLLBusy endp

;################################################################

DLLIndexH2viewer PROC  aKeyword:DWORD 
	Ih2vmain Index,aKeyword
 FindeDLLIndexH2viewer:
         ret
DLLIndexH2viewer endp

;################################################################

DLLSearchH2viewer PROC  aSearchTerm:DWORD 
	Ih2vmain Search,aSearchTerm
 FindeDLLSearchH2viewer:
         ret
DLLSearchH2viewer endp

;################################################################
DLLPageTab PROC  aPage:DWORD 
	Ih2vmain PageTab,aPage
 FindeDLLPageTab:
         ret
DLLPageTab endp

;################################################################
ThreadStartH2viewer PROC   
	Local szNULL[8]:BYTE
	Local reponse:DWORD,pbstrFilter,bstrFilter,Hwindow
	LOCAL wszNull[8]:Word	
	Local  retour:DWORD	
	ZEROLOCALES retour
		;pas d'appel com depuis thread
		.if countdll == 1
			Invoke CoInitializeEx,NULL,COINIT_APARTMENTTHREADED		
			;invoke DebugBreak	
				invoke InitIh2vmain  
				.if eax == 1	;ok ppvIh2vmain valide
					@@:
					;---------- recommand ---------------
					Ih2vmain WindowHandle,addr Hwindow
					.if Hwindow == 0
						invoke Sleep,100
						jmp @B
					.endif
					invoke CreateBstr,addr wszNull
					mov bstrFilter,eax
					Ih2vmain Open,sthread.bstrnamespace,bstrFilter,bstrFilter
					.if eax == S_OK 
						invoke SysFreeString,reponse
					.else
						call Failed_Init_Ih2vmain
					.endif
				.endif
			.endif
	invoke ExitThread,NULL		
	invoke CloseHandle,sthread.Htread
	mov sthread.Htread,0
	mov sthread.threadid,0		
	invoke FreeBSTR

 FindeThreadStartH2viewer:
         mov eax,retour
         ret
Failed_Init_Ih2vmain:
	Ih2vmain Release
	mov ppvIh2vmain,0
retn

ThreadStartH2viewer endp

;################################################################
ValidH2viewer PROC 
			Local Hwindow:DWORD
			Local  retour:DWORD
         mov retour,0
	mov Hwindow,0
	.if ppvIh2vmain != 0
		Ih2vmain WindowHandle,addr Hwindow
		.if Hwindow != 0
			PuPo retour,Hwindow
		.endif
	.endif

 FindeValidH2viewer:
         mov eax,retour
         ret
ValidH2viewer endp

;################################################################



;################################################################


StartH2viewer PROC bstrnamespace:DWORD 
		;a peut tre long
		;PuPo sthread.bstrnamespace,bstrnamespace
		;invoke CreateThread,NULL,NULL,offset ThreadStartH2viewer,NULL,NULL,addr sthread.threadid
		; sthread.Htread,eax	
	Local szNULL[8]:BYTE
	Local reponse:DWORD,pbstrFilter,bstrFilter,Hwindow
	LOCAL wszNull[8]:Word	
	Local  retour:DWORD	
	ZEROLOCALES retour
		
		.if countdll == 1
			Invoke CoInitializeEx,NULL,COINIT_APARTMENTTHREADED		
			;invoke DebugBreak	
				invoke InitIh2vmain  
				.if eax == 1	;ok ppvIh2vmain valide
					@@:
					;---------- recommand ---------------
					Ih2vmain WindowHandle,addr Hwindow
					.if Hwindow == 0
						invoke Sleep,100
						jmp @B
					.endif
					invoke CreateBstr,addr wszNull
					mov bstrFilter,eax
					Ih2vmain Open,bstrnamespace,bstrFilter,bstrFilter
					.if eax == S_OK 
						invoke SysFreeString,reponse
					.else
						call Failed_Init_Ih2vmain
					.endif
				.endif
			.endif
	invoke FreeBSTR		

 FindeStartH2viewer:
         ret
Failed_Init_Ih2vmain:
	Ih2vmain Release
	mov ppvIh2vmain,0
retn
StartH2viewer endp


;################################################################
EndH2viewer PROC 
			Local Hwindow:DWORD
			Local  retour:DWORD
         mov retour,1
	Ih2vmain ShowWindow,0
	Ih2vmain WindowHandle,addr Hwindow	
	invoke SendMessage,Hwindow,WM_DESTROY,NULL,NULL
	Ih2vmain Release
	invoke CoUninitialize
 FindeEndH2viewer:
         mov eax,retour
         ret
EndH2viewer endp

;################################################################
InitIh2vmain PROC 
			Local  retour:DWORD
         mov retour,0
		.if ppvIh2vmain == 0
			invoke GetInterfaceFromProgId,SADR("H2Viewer.h2vmain"),addr IID_Ih2vmain
			.if eax > 10
				mov ppvIh2vmain,eax
				mov retour,1
			.endif
		.endif
 FindeInitIh2vmain:
         mov eax,retour
         ret
InitIh2vmain endp

;################################################################
;CLSID
;{31411198-a502-11d2-bbca-00c04f8ec294}	HxSession Class
;{314111c7-a502-11d2-bbca-00c04f8ec294}	HxProtocol Class
;{314111c9-a502-11d2-bbca-00c04f8ec294}	HxProtocol Class
;{314111f0-a502-11d2-bbca-00c04f8ec294}	HxRegistryWalker Class
;{314111f7-a502-11d2-bbca-00c04f8ec294}	HxParseDisplayName Class
;{31411219-a502-11d2-bbca-00c04f8ec294}	HxRegisterSession Class
;{31411228-a502-11d2-bbca-00c04f8ec294}	HxRegisterProtocol Class
;{31430c59-bed1-11D1-8De8-00C04FC2E0C7}	HxRegisterProtocol Class

;IID
;HxDs.HxRegistryWalker HxDs.HxRegistryWalker.1
;IID_IHxRegistryWalker
;{314111EF-A502-11D2-BBCA-00C04F8EC294}	IHxRegistryWalker
;{314111F1-A502-11D2-BBCA-00C04F8EC294}	IHxRegNamespace
;{314111F3-A502-11D2-BBCA-00C04F8EC294}	IHxRegNamespaceList

GetNameSpace PROC uses ebx memheap:DWORD
			Local  szNULL[8]:BYTE
			Local  phrase[MAX_PATH]:BYTE
			Local  pfiltre:DWORD,nbNameSpaces,pRegNamespace,bstrNamespace
			Local  retour:DWORD
			ZEROLOCALES retour
      mov retour,0
	Invoke CoInitializeEx,NULL,COINIT_APARTMENTTHREADED			
	;si on ne l'a pas dja fait
	invoke CoCreateInstance,addr CLSID_HxRegistryWalker, NULL, CLSCTX_ALL,
		addr IID_IHxRegistryWalker, offset ppvIHxRegistryWalker
	;invoke GetInterfaceFromProgId,SADR("HxDs.HxRegistryWalker"),addr IID_IHxRegistryWalker
	.if eax != S_OK
		jmp  FindeGetNameSpace
	;.else
		;mov ppvIHxRegistryWalker,eax
	.endif
	invoke CreateBstr,addr szNULL
	mov pfiltre,eax
	IHxRegistryWalker RegisteredNamespaceList,pfiltre,addr ppvIHxRegNamespaceList
	.if eax == S_OK && ppvIHxRegNamespaceList != 0			
		IHxRegNamespaceList Count,addr nbNameSpaces
		.if nbNameSpaces == 0
			;pas install
			IHxRegNamespaceList Release
			IHxRegistryWalker Release
			jmp FindeGetNameSpace
		.endif
		.while(nbNameSpaces)
			;------- valeur du Namespace dans la base de registre
			;IHxRegNamespaceList Item,vnbNameSpaces,addr ppvIHxRegNamespace			
			IHxRegNamespaceList ItemAt,nbNameSpaces,addr ppvIHxRegNamespace
			IHxRegNamespace Name1,addr bstrNamespace
			IHxRegNamespace Release
			invoke WideCharToMultiByte,CP_ACP,NULL,bstrNamespace,-1,addr phrase,sizeof phrase,
						NULL,NULL
			.if eax != 0
				mov edx,eax		;la longueur comprend le zro
				.if eax > 3		;pas de "Hx",inutilisable
					invoke WriteToMemHeap,memheap,addr phrase,edx
					inc retour
				.endif
			.endif
			invoke SysFreeString,bstrNamespace				
			dec nbNameSpaces
		.endw
		;plus besoin,on garde la liste
		IHxRegNamespaceList Release
		IHxRegistryWalker Release
		mov eax,memheap
		mov edx,[eax].MEMHEAP.Pheap
	.else
		jmp FindeGetNameSpace
	.endif		
	invoke CoUninitialize
 FindeGetNameSpace:
         mov eax,retour
         ret
GetNameSpace endp

;################################################################

CreateBstr PROC  pChain:DWORD  
			Local  retour:DWORD
			Local   phrase[MAX_PATH]:WORD 
	invoke MultiByteToWideChar,CP_ACP,MB_PRECOMPOSED,pChain,\
		-1,addr phrase,sizeof phrase  
	invoke SysAllocString,addr phrase
	mov retour,eax	
	.if eax == 0
		invoke MessageBox,NULL,SADR("FAILED"),SADR("MultiByteToWideChar"),MB_OK
		jmp FindeCreateBstr
	.endif
	;---------------- save pointer in an array array_bstr -----------------
	lea edx,array_bstr
	.LISTALL
	mov ecx,LENGTHOF array_bstr
	.NOLIST
	@@:
	.if dword ptr [edx] == 0
		mov [edx],eax
	.else
		dec ecx
		.if ecx != 0	;not the end of array
			add edx,4
			jmp @B
		.else
			;failed to save bstr pointer			
			invoke MessageBox,NULL,SADR("array_bstr array too small"),SADR("ERREUR"),MB_OK
			invoke SysFreeString,retour
			mov retour,0			
		.endif
	.endif
 FindeCreateBstr:
         mov eax,retour
         ret
CreateBstr endp

;################################################################
FreeBSTR PROC uses esi
			Local count:DWORD
			Local  retour:DWORD
         mov retour,1
	mov ecx,LENGTHOF array_bstr
	mov count,ecx
	lea esi,array_bstr
	@@:
	.if dword ptr [esi] != 0
		mov edx,[esi]
		invoke SysFreeString,edx
		mov dword ptr [esi],0
		add esi,4
		dec count
		jnz @B
	.endif
 FindeFreeBSTR:
         mov eax,retour
         ret
FreeBSTR endp



End DllEntry		;

