

	HIWORD MACRO ParamFen
		mov eax,ParamFen
		shr eax,16
	ENDM
	LOWORD MACRO ParamFen
		mov eax,ParamFen
		and eax,0FFFFh
	ENDM
	
      FUNC MACRO parameters:VARARG
        invoke parameters
        EXITM <eax>
      ENDM

      PuPo MACRO M1, M2
        push M2
        pop  M1
      ENDM

	InsTxt MACRO Name, Text:VARARG
	LOCAL lbl
		jmp lbl
		Name db Text,0
	lbl:
	ENDM
	return MACRO valeur
		mov eax,valeur
		ret
	ENDM
	
	
		ZEROLOCALES MACRO dernierelocale:REQ
			mov ecx,ebp
			lea edx,dernierelocale
			sub ecx,edx
			.if ecx != 0
				push edi
				mov edi,edx
				mov al,0
				cld
				rep stosb
				pop edi			
			.endif
		ENDM


    ; --------------------------------------------------------
    ; Cre une donne en data,renvoie l'tiquette de la chaine
    ; La cration du nom de l'tiquette est facultatif
    ; la macro vrifie la syntaxe des chaines et tiquettes
    ; ---------------------------------------------------------
      CREDATA MACRO quoted_text:REQ,NomdeChaine
		LOCAL Local_Etiquette,verif
	IFNB <NomdeChaine>			;present
		verif SUBSTR <NomdeChaine>,1,1
      		IFIDN verif,<">            ;si le premier caractere est "
			.ERR  <ETIQUETTE SUPRIMER les " >			
		ENDIF
	Local_Etiquette TEXTEQU <NomdeChaine>		;changer le nom d'tiquette
	ENDIF
	verif SUBSTR <quoted_text>,1,1				
	IFDIF verif,<">
		.ERR  <CHAINE AJOUTER LES " >
	ENDIF
	
		.data
		Local_Etiquette db quoted_text,0
		.code
		EXITM <Local_Etiquette>
      ENDM
    ; ----------------------------------------------------
    ; Sort l' adresse de la chaine crer, SADR("chaine")
    ; -----------------------------------------------------
      	SADR MACRO quoted_text:REQ,NomdeChaine
        	EXITM <ADDR CREDATA(quoted_text,NomdeChaine)>
      	ENDM
    ; ----------------------------------------------------
    ; Sort l' offset de la chaine crer, SADR("chaine")
    ; -----------------------------------------------------
	SOFF MACRO quoted_text:REQ,NomdeChaine
        	EXITM <Offset CREDATA(quoted_text,NomdeChaine)>
      	ENDM	

	comment 
	lea edx,FindeProgramme
	invoke InstalleExceptions,SADR("c:\masm32\ref\dbghelp.dll"),\
			DebutdeProgramme,edx
	.if eax == 0
		jmp Findeminus
	.endif
	mov Hdbghelp,eax 
	
	
; macro d'cran
	;usage	 mov resultat,HAUTEUR( Rct)
	HAUTEUR MACRO Adrrect:REQ
		push ebx
		lea ebx,Adrrect
		mov     eax,(RECT ptr [ebx]).bottom                 ; y bas origine coin haut gauche 0,0
		sub     eax,(RECT ptr [ebx]).top	  			; y haut	
		pop ebx
	EXITM <eax>
	ENDM
	LARGEUR MACRO Adrrect:REQ
		push ebx
		lea ebx,Adrrect
		mov     eax,(RECT ptr [ebx]).right       ; x coin droit bas  origine coin haut gauche 0,0
		sub     eax, (RECT ptr [ebx]).left      ; x coin gauche haut 
		pop ebx
	EXITM <eax>
	ENDM
		;calculs annexes utilise edx
	XMIN MACRO Adrrect:REQ
		push ebx
		lea ebx,Adrrect
		mov     edx,(RECT ptr [ebx]).left
		pop ebx
	EXITM <edx>
	ENDM
	YMIN MACRO Adrrect:REQ
		push ebx
		lea ebx,Adrrect
		mov     edx,(RECT ptr [ebx]).top
		pop ebx
	EXITM <edx>
	ENDM
	XMAX MACRO Adrrect:REQ
		push ebx
		lea ebx,Adrrect
		mov     edx,(RECT ptr [ebx]).right
		pop ebx
	EXITM <edx>
	ENDM
	YMAX MACRO Adrrect:REQ
		push ebx
		lea ebx,Adrrect
		mov     edx,(RECT ptr [ebx]).bottom
		pop ebx
	EXITM <edx>
	ENDM	

;--------------- macro pour exception ------------------------------------------------
	;usage
	;EXCEPT ("je me trouve dans macro.inc"),Nomproc,Param1,Param2.....
	;remplace: invoke Nomproc,Param1,Param2

	EXCEPT MACRO NomProc:REQ,parameters:VARARG
		LOCAL Local_Etiquette
		LOCAL localinvoke
		;rajouter des push ii pour augmenter le nombre de renseignements		
		xor eax,eax	;retour	
		push eax								;pointeur +24
		push EBP     ;sauvegarde ebp  					;pointeur +20
		lea eax,localinvoke
		push eax								;pointeur +16 la pile
		
		mov eax,ADRESSE NomProc						;pointeur +12
					;la phrase identifiant l'erreur
		push eax        	;
		lea eax,Local_Etiquette
		push eax								;pointeur +8
		lea eax,HANDLER	;la nouvelle routine d'exceptions
		push eax								;pointeur +4
		assume FS:NOTHING
		push FS:[0]       	;conserve l'ancien pointeur sur ERR      ;pointeur +0
		mov FS:[0],esp      	;remplacer l'ancien pointeur sur ERR par le nouveau,--
		localinvoke:		;---------------ce qui du meme coup sauvegarde esp
		invoke parameters	;rajouter la ligne tel que
		mov [esp+24],eax	;tout s'est bien passer,prserve la valeur de retour
		Local_Etiquette:		
		mov eax,[esp+24]	;prend la valeur de retour ,modifi en cas d'exceptions
		pop FS:[0]          	;retablir l'ancien err quand la zone protge est termine
		add esp,24          	;6 dword en pile effacer
	ENDM
	
	ADRESSE MACRO bidule:REQ
		EXITM <offset CREDATA (bidule)>
	ENDM

